import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BookingCard, BookingCardParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询会员卡
 */
export async function pageBookingCard(params: BookingCardParam) {
  const res = await request.get<ApiResult<PageResult<BookingCard>>>(
    MODULES_API_URL + '/booking/booking-card/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询会员卡列表
 */
export async function listBookingCard(params?: BookingCardParam) {
  const res = await request.get<ApiResult<BookingCard[]>>(
    MODULES_API_URL + '/booking/booking-card',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加会员卡
 */
export async function addBookingCard(data: BookingCard) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-card',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改会员卡
 */
export async function updateBookingCard(data: BookingCard) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-card',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除会员卡
 */
export async function removeBookingCard(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-card/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除会员卡
 */
export async function removeBatchBookingCard(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-card/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询会员卡
 */
export async function getBookingCard(id: number) {
  const res = await request.get<ApiResult<BookingCard>>(
    MODULES_API_URL + '/booking/booking-card/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
